XIncludeFile ".\libtcod\TCOD_const.pbi"
XIncludeFile ".\libtcod\TCOD_color.pbi"

;- +++ Structure

;- console.h
Structure TCOD_key_t  
  vk.l
  c.b
  pressed.b
  lalt.b
  lctrl.b
  ralt.b
  rctrl.b
  shift.b
  PB_Align(0,1)
EndStructure

;- +++ Prototype

;- console.h
PrototypeC   TCOD_console_set_custom_font(fontFile.p-ascii, flags.l, nb_char_horiz.l, nb_char_vertic.l)
PrototypeC   TCOD_console_init_root(w.i,h.i,title.p-ascii,fullscreen.b)
PrototypeC   TCOD_console_is_window_closed()
PrototypeC   TCOD_console_set_foreground_color(con.i,col.i)
PrototypeC   TCOD_console_print_left(con.i,x.i,y.i,flag.l, fmt.p-ascii)
PrototypeC   TCOD_console_flush()
PrototypeC   TCOD_console_is_key_pressed(key.i)
PrototypeC   TCOD_console_set_fullscreen(fullscreen.b)
PrototypeC   TCOD_console_is_fullscreen()
PrototypeC   TCOD_console_check_for_keypress(*pointer.TCOD_key_t,flags.l)
PrototypeC   TCOD_console_wait_for_keypress(*ret.TCOD_key_t,flush.b)
PrototypeC   TCOD_console_delete(console.i)
PrototypeC.i TCOD_console_new(w.l, h.l)
PrototypeC   TCOD_console_blit(src.l,xSrc.l,ySrc.l, wSrc.l, hSrc.l, dst.l, xDst.l, yDst.l, foreground_alpha.f = 1.0, background_alpha.f = 1.0)
PrototypeC   TCOD_console_put_char(con.i,x.l, y.l, c.l, flag.l);
PrototypeC   TCOD_console_set_background_color(con.l,col.l)
PrototypeC   TCOD_console_set_back(con.i,x.i,y.i,col.i,flag.l);

PrototypeC   TCOD_console_set_window_title(title.p-ascii) ;################ Testen
PrototypeC   TCOD_console_map_ascii_code_to_font(asciiCode.i,fontCharX.i,fontCharY.i)
PrototypeC   TCOD_console_map_ascii_codes_to_font(asciiCode.i, nbCodes.i, fontCharX.i, fontCharY.i)
PrototypeC   TCOD_console_map_string_to_font(s.p-ascii, fontCharX.i, fontCharY.i)
PrototypeC   TCOD_console_set_dirty(x.i, y.i, w.i, h.i)
PrototypeC   TCOD_console_clear(con.i)
PrototypeC   TCOD_console_set_fore(con.i,x.i, y.i, col.i)
PrototypeC   TCOD_console_set_char(con.i,x.i, y.i, c.i)
PrototypeC   TCOD_console_put_char_ex(con.i,x.i, y.i, c.i, fore.i, back.i)
PrototypeC   TCOD_console_print_right(con.i,x.i, y.i, flag.l, fmt.p-ascii) 
PrototypeC   TCOD_console_print_center(con.i,x.i, y.i, flag.l, fmt.p-ascii) 
PrototypeC.i TCOD_console_print_left_rect(con.i,x.i, y.i, w.i, h.i, flag.l, fmt.p-ascii) 
PrototypeC.i TCOD_console_print_right_rect(con.i,x.i, y.i, w.i, h.i, flag.l, fmt.p-ascii) 
PrototypeC.i TCOD_console_print_center_rect(con.i, x.i, y.i, w.i, h.i, flag.l, fmt.p-ascii) 
PrototypeC.i TCOD_console_height_left_rect(con.i,x.i, y.i, w.i, h.i, fmt.p-ascii)
PrototypeC.i TCOD_console_height_right_rect(con.i,x.i, y.i, w.i, h.i, fmt.p-ascii)
PrototypeC.i TCOD_console_height_center_rect(con.i,x.i, y.i, w.i, h.i, fmt.p-ascii)
PrototypeC   TCOD_console_rect(con.i,x.i, y.i, w.i, h.i, clear.i, flag.l) ; clear is bool
PrototypeC   TCOD_console_hline(con.i,x.i,y.i, l.i, flag.l)
PrototypeC   TCOD_console_vline(con.i,x.i,y.i, l.i, flag.l)
PrototypeC   TCOD_console_print_frame(con.i,x.i,y.i,w.i,h.i, empty.i, flag.l, fmt.p-ascii) ;empty is bool
PrototypeC.i TCOD_console_get_background_color(con.i) ;returns TCOD_color_t
PrototypeC.i TCOD_console_get_foreground_color(con.i) ;returns TCOD_color_t
PrototypeC.i TCOD_console_get_back(con.i,x.i, y.i) ;returns TCOD_color_t
PrototypeC.i TCOD_console_get_fore(con.i,x.i, y.i) ;returns TCOD_color_t
PrototypeC.i TCOD_console_get_char(con.i,x.i, y.i)
PrototypeC   TCOD_console_set_fade(val.i, fade.i) ;val is uint8
PrototypeC.i TCOD_console_get_fade() ;returns uint8
PrototypeC.i TCOD_console_get_fading_color()
PrototypeC   TCOD_console_set_color_control(con.i, fore.i, back.i)
PrototypeC   TCOD_console_set_keyboard_repeat(initial_delay.i, interval.i)
PrototypeC   TCOD_console_disable_keyboard_repeat()
PrototypeC.i TCOD_console_get_width(con.i)
PrototypeC.i TCOD_console_get_height(con.i)
PrototypeC   TCOD_console_set_key_color(con.i,col.i)
PrototypeC   TCOD_console_credits()
PrototypeC   TCOD_console_credits_reset()
PrototypeC   TCOD_console_credits_render(x.i, y.i, alpha.i) ;bool; alpha is bool

;- FOV.h
; allocate a new Map
PrototypeC   TCOD_map_new(width.i, height.i)
; set all cells As solid rock (cannot see through nor walk)
PrototypeC   TCOD_map_clear(FOVMap.i)
; copy a Map To another, reallocating it when needed
PrototypeC   TCOD_map_copy(source.i, dest.i)
; change a cell properties
PrototypeC   TCOD_map_set_properties(FOVMap.i, x.i, y.i, is_transparent.i, is_walkable.i) ;is_transparent and is_walable are bool
; destroy a Map
PrototypeC   TCOD_map_delete(FOVMap.i)
; calculate the field of view (potentially visible cells from player_x,player_y)
PrototypeC   TCOD_map_compute_fov(FOVMap.i, player_x.i, player_y.i, max_radius.i, light_walls.i, algo.i) ;light_walls is bool
; check If a cell is in the last computed field of view
PrototypeC   TCOD_map_is_in_fov(FOVMap.i, x.i, y.i) ;returns bool
PrototypeC   TCOD_map_set_in_fov(FOVMap.i, x.i, y.i, fov.i) ;fov is bool
; retrieve properties from the Map
PrototypeC   TCOD_map_is_transparent(FOVMap.i, x.i, y.i) ;returns bool
PrototypeC   TCOD_map_is_walkable(FOVMap.i, x.i, y.i) ; returns bool
PrototypeC.i TCOD_map_get_width(FOVMap.i)
PrototypeC.i TCOD_map_get_height(FOVMap.i)
PrototypeC.i TCOD_map_get_nb_cells(FOVMap.i)

;- +++ GetFunction
libtcod = OpenLibrary(#PB_Any,"libtcod-vs.dll")
;libtcod = OpenLibrary(#PB_Any,"libtcod-mingw.dll")
If libtcod <> 0
  ;- console.h
  Global TCOD_console_set_custom_font.TCOD_console_set_custom_font = GetFunction(libtcod,"TCOD_console_set_custom_font")
  Global TCOD_console_init_root.TCOD_console_init_root = GetFunction(libtcod,"TCOD_console_init_root")
  Global TCOD_console_is_window_closed.TCOD_console_is_window_closed = GetFunction(libtcod,"TCOD_console_is_window_closed")
  Global TCOD_console_set_foreground_color.TCOD_console_set_foreground_color = GetFunction(libtcod,"TCOD_console_set_foreground_color")
  Global TCOD_console_print_left.TCOD_console_print_left = GetFunction(libtcod,"TCOD_console_print_left")
  Global TCOD_console_flush.TCOD_console_flush = GetFunction(libtcod,"TCOD_console_flush")
  Global TCOD_console_is_key_pressed.TCOD_console_is_key_pressed = GetFunction(libtcod,"TCOD_console_is_key_pressed")
  Global TCOD_console_set_fullscreen.TCOD_console_set_fullscreen = GetFunction(libtcod,"TCOD_console_set_fullscreen")
  Global TCOD_console_is_fullscreen.TCOD_console_is_fullscreen = GetFunction(libtcod,"TCOD_console_is_fullscreen")
  Global TCOD_console_check_for_keypress.TCOD_console_check_for_keypress = GetFunction(libtcod,"TCOD_console_check_for_keypress")      
  Global TCOD_console_wait_for_keypress.TCOD_console_wait_for_keypress = GetFunction(libtcod,"TCOD_console_wait_for_keypress")  
  Global TCOD_console_new.TCOD_console_new   = GetFunction(libtcod,"TCOD_console_new")
  Global TCOD_console_blit.TCOD_console_blit = GetFunction(libtcod,"TCOD_console_blit")  
  Global TCOD_console_put_char.TCOD_console_put_char = GetFunction(libtcod,"TCOD_console_put_char")
  Global TCOD_console_set_background_color.TCOD_console_set_background_color = GetFunction(libtcod,"TCOD_console_set_background_color")
  Global TCOD_console_set_back.TCOD_console_set_back = GetFunction(libtcod,"TCOD_console_set_back")
  
  Global TCOD_console_set_window_title.TCOD_console_set_window_title = GetFunction(libtcod, "TCOD_console_set_window_title") ;################ Testen
  Global TCOD_console_map_ascii_code_to_font.TCOD_console_map_ascii_code_to_font = GetFunction(libtcod, "TCOD_console_map_ascii_code_to_font")
  Global TCOD_console_map_ascii_codes_to_font.TCOD_console_map_ascii_codes_to_font = GetFunction(libtcod, "TCOD_console_map_ascii_codes_to_font")
  Global TCOD_console_map_string_to_font.TCOD_console_map_string_to_font = GetFunction(libtcod, "TCOD_console_map_string_to_font")
  Global TCOD_console_set_dirty.TCOD_console_set_dirty = GetFunction(libtcod, "TCOD_console_set_dirty")
  Global TCOD_console_clear.TCOD_console_clear = GetFunction(libtcod, "TCOD_console_clear")
  Global TCOD_console_set_fore.TCOD_console_set_fore = GetFunction(libtcod, "TCOD_console_set_fore")
  Global TCOD_console_set_char.TCOD_console_set_char = GetFunction(libtcod, "TCOD_console_set_char")
  Global TCOD_console_put_char_ex.TCOD_console_put_char_ex = GetFunction(libtcod, "TCOD_console_put_char_ex")
  Global TCOD_console_print_right.TCOD_console_print_right = GetFunction(libtcod, "TCOD_console_print_right") 
  Global TCOD_console_print_center.TCOD_console_print_center = GetFunction(libtcod, "TCOD_console_print_center") 
  Global TCOD_console_print_left_rect.TCOD_console_print_left_rect = GetFunction(libtcod, "TCOD_console_print_left_rect") 
  Global TCOD_console_print_right_rect.TCOD_console_print_right_rect = GetFunction(libtcod, "TCOD_console_print_right_rect") 
  Global TCOD_console_print_center_rect.TCOD_console_print_center_rect = GetFunction(libtcod, "TCOD_console_print_center_rect") 
  Global TCOD_console_height_left_rect.TCOD_console_height_left_rect = GetFunction(libtcod, "TCOD_console_height_left_rect")
  Global TCOD_console_height_right_rect.TCOD_console_height_right_rect = GetFunction(libtcod, "TCOD_console_height_right_rect")
  Global TCOD_console_height_center_rect.TCOD_console_height_center_rect = GetFunction(libtcod, "TCOD_console_height_center_rect")
  Global TCOD_console_rect.TCOD_console_rect = GetFunction(libtcod, "TCOD_console_rect") ; clear is bool
  Global TCOD_console_hline.TCOD_console_hline = GetFunction(libtcod, "TCOD_console_hline")
  Global TCOD_console_vline.TCOD_console_vline = GetFunction(libtcod, "TCOD_console_vline")
  Global TCOD_console_print_frame.TCOD_console_print_frame = GetFunction(libtcod, "TCOD_console_print_frame") ;empty is bool
  Global TCOD_console_get_background_color.TCOD_console_get_background_color = GetFunction(libtcod, "TCOD_console_get_background_color") ;returns TCOD_color_t
  Global TCOD_console_get_foreground_color.TCOD_console_get_foreground_color = GetFunction(libtcod, "TCOD_console_get_foreground_color") ;returns TCOD_color_t
  Global TCOD_console_get_back.TCOD_console_get_back = GetFunction(libtcod, "TCOD_console_get_back") ;returns TCOD_color_t
  Global TCOD_console_get_fore.TCOD_console_get_fore = GetFunction(libtcod, "TCOD_console_get_fore") ;returns TCOD_color_t
  Global TCOD_console_get_char.TCOD_console_get_char = GetFunction(libtcod, "TCOD_console_get_char")
  Global TCOD_console_set_fade.TCOD_console_set_fade = GetFunction(libtcod, "TCOD_console_set_fade") ;val is uint8
  Global TCOD_console_get_fade.TCOD_console_get_fade = GetFunction(libtcod, "TCOD_console_get_fade") ;returns uint8
  Global TCOD_console_get_fading_color.TCOD_console_get_fading_color = GetFunction(libtcod, "TCOD_console_get_fading_color")
  Global TCOD_console_set_color_control.TCOD_console_set_color_control = GetFunction(libtcod, "TCOD_console_set_color_control")
  Global TCOD_console_set_keyboard_repeat.TCOD_console_set_keyboard_repeat = GetFunction(libtcod, "TCOD_console_set_keyboard_repeat")
  Global TCOD_console_disable_keyboard_repeat.TCOD_console_disable_keyboard_repeat = GetFunction(libtcod, "TCOD_console_disable_keyboard_repeat")
  Global TCOD_console_get_width.TCOD_console_get_width = GetFunction(libtcod, "TCOD_console_get_width")
  Global TCOD_console_get_height.TCOD_console_get_height = GetFunction(libtcod, "TCOD_console_get_height")
  Global TCOD_console_set_key_color.TCOD_console_set_key_color = GetFunction(libtcod, "TCOD_console_set_key_color")
  Global TCOD_console_credits.TCOD_console_credits = GetFunction(libtcod, "TCOD_console_credits")
  Global TCOD_console_credits_reset.TCOD_console_credits_reset = GetFunction(libtcod, "TCOD_console_credits_reset")
  Global TCOD_console_credits_render.TCOD_console_credits_render = GetFunction(libtcod, "TCOD_console_credits_render") ;bool; alpha is bool
  
  ;- FOV.h
  ; allocate a new map
Global TCOD_map_new.TCOD_map_new = GetFunction(libtcod, "TCOD_map_new")
; set all cells as solid rock (cannot see through nor walk)
Global TCOD_map_clear.TCOD_map_clear = GetFunction(libtcod, "TCOD_map_clear")
; copy a map to another, reallocating it when needed
Global TCOD_map_copy.TCOD_map_copy = GetFunction(libtcod, "TCOD_map_copy")
; change a cell properties
Global TCOD_map_set_properties.TCOD_map_set_properties = GetFunction(libtcod, "TCOD_map_set_properties")
; destroy a map
Global TCOD_map_delete.TCOD_map_delete = GetFunction(libtcod, "TCOD_map_delete")
; calculate the field of view (potentially visible cells from player_x,player_y)
Global TCOD_map_compute_fov.TCOD_map_compute_fov = GetFunction(libtcod, "TCOD_map_compute_fov")
; check if a cell is in the last computed field of view
Global TCOD_map_is_in_fov.TCOD_map_is_in_fov = GetFunction(libtcod, "TCOD_map_is_in_fov") ;returns bool
Global TCOD_map_set_in_fov.TCOD_map_set_in_fov = GetFunction(libtcod, "TCOD_map_set_in_fov")
; retrieve properties from the map
Global TCOD_map_is_transparent.TCOD_map_is_transparent = GetFunction(libtcod, "TCOD_map_is_transparent") ;returns bool
Global TCOD_map_is_walkable.TCOD_map_is_walkable = GetFunction(libtcod, "TCOD_map_is_walkable") ; returns bool
Global TCOD_map_get_width.TCOD_map_get_width = GetFunction(libtcod, "TCOD_map_get_width")
Global TCOD_map_get_height.TCOD_map_get_height = GetFunction(libtcod, "TCOD_map_get_height")
Global TCOD_map_get_nb_cells.TCOD_map_get_nb_cells = GetFunction(libtcod, "TCOD_map_get_nb_cells")
  
Else
  MessageRequester("Fehler","libtcod-VS.dll konnte nicht geladen werden.")
  End
EndIf 
; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 186
; FirstLine = 142
; EnableXP